import { removeStylesOfHighlightedElements, setModalContent } from '../features/index.js';

/**
 * @param {string} currentStep
 */

export const chatWindow = (currentStep) => {
  removeStylesOfHighlightedElements();

  const $chatWindow = document.getElementById('chat_block');
  const $leftIcon = document.getElementById('chatLeftIcon');
  const $textInput = document.getElementById('textmsg');
  const $sendButton = document.getElementById('sendButtonTextMsg');

  $chatWindow.classList.add('highlightedTrainingElement', 'highlightedTrainingElementBackground');
  $leftIcon.classList.add('highlightedTrainingElement', 'highlightedTrainingElementPosition');
  $textInput.classList.add('highlightedTrainingElement', 'highlightedTrainingElementPosition');
  $sendButton.classList.add('highlightedTrainingElement', 'highlightedTrainingElementPosition');

  setModalContent({
    keyTitle: 'newCombats.trainingModal.step2.title',
    keyContent: 'newCombats.trainingModal.step2.text',
    currentStep,
  });
};
