<?php

use Enum\ShopId;

?>
<style>
    .wares {
        display: grid;
        grid-template-columns: 100px auto;
        background-color: #d4d4d4;
    }

    .wares > div:nth-child(odd of .left), .wares > div:nth-child(odd of .left) + div {
        background-color: #c8c8c8;
    }

    table.zerowide {
        width: 100%;
        border-spacing: 0;
        border-collapse: collapse;
    }

    table.zerowide td {
        padding: 0;
    }
</style>
<form id="F1" name="F1" method="post"></form>
<table class="zerowide">
    <tr>
        <td style="vertical-align: top;">
            <h3><?= $shopName ?></h3>
            <div style="text-align: center; font-weight: bold;"><span style="color: crimson;">&nbsp;<?= $status ?></span></div>
            <table class="zerowide">
                <tr>
                    <td style="text-align: left; vertical-align: top; padding: 4px;">
                        <!--Магазин-->
                        <div id="hint3" style="visibility:hidden"></div>
                        <table class="zerowide" style="background-color: darkgrey;">
                            <tr>
                                <td style="text-align: center; height: 21px;">
                                    <?php if ($actionSale): ?>
                                        <strong>Отдел «Скупка»</strong><br>
                                        Здесь вы можете продать свои вещи, за жалкие гроши...<br>
                                        У вас в наличии:
                                    <?php elseif ($actionGifts): ?>
                                        <strong>Отдел «Сделать подарки»</strong>
                                    <?php elseif ($shop->shopOtdel->getName($otdel)): ?>
                                        <strong>Отдел «<?= $shop->shopOtdel->getName($otdel) ?>»</strong>
                                    <?php endif; ?>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <!--Рюкзак / Прилавок-->
                                    <table class="zerowide" style="background-color: dimgrey;">
                                        <?php if ($actionGifts): ?>
                                            <tr>
                                                <td style="background-color: #d5d5d5;">
                                                    Вы можете сделать подарок дорогому человеку. Ваш подарок будет отображаться в информации о персонаже.
                                                    <input name="itemgift" id="itemgift" type="hidden" value="0" form="F1">
                                                    <ol>
                                                        <li>
                                                            Укажите имя персонажа, которому хотите сделать подарок.
                                                            <label>Имя <input name="to_login" form="F1"></label>
                                                        </li>
                                                        <?php if ($u->info['exp'] >= Present::EXP_NEEDED_FOR_ADD_PRESENT_TEXT): ?>
                                                            <li>
                                                                Поздравление. Будет отображаться в информации о персонаже (не более 60 символов).
                                                                <label><input name="podarok2" size="50" maxlength="60" form="F1"></label>
                                                            </li>
                                                            <li>
                                                                Приватное поздравление (в информации о персонаже не отображается).
                                                                <label><textarea name="txt" cols="80" rows="6" form="F1"></textarea></label>
                                                            </li>
                                                        <?php endif; ?>
                                                        <li>
                                                            Выберите, от чьего имени подарок:<br>
                                                            <label style="font-weight: bold;"><input type="radio" name="from" value="0" checked form="F1"> <?= $u->info['login'] ?></label><br>
                                                            <label><input type="radio" name="from" value="1" form="F1">анонимно</label><br>
                                                            <?php if ($uc->isRegistered()): ?>
                                                                <label><input type="radio" name="from" value="2" form="F1">от имени клана <?= $uc->getName() ?></label>
                                                            <?php endif; ?>
                                                        </li>
                                                        <li>
                                                            Нажмите кнопку <strong>Подарить</strong> под предметом, который хотите преподнести в подарок:<br>
                                                        </li>
                                                    </ol>
                                                </td>
                                            </tr>
                                            <?php if ($giftsvars): ?>
                                                <?php foreach ($giftsvars as $k => $v): ?>
                                                    <tr>
                                                        <td style="text-align: center; background-color: lightgrey;">
                                                            <?php if ($k === 0): ?>
                                                                <h3>Уникальные подарки</h3>
                                                            <?php endif; ?>
                                                            <table class="zerowide">
                                                                <tr>
                                                                    <td style="width: 160px; text-align: center; border-right: 1px solid #a5a5a5; padding: 5px;">
                                                                        <img style="padding-bottom: 5px;" src="<?= $v['img'] ?>" alt=""><br>
                                                                        <button onclick="document.getElementById('itemgift').value=<?= $v['jsvalue'] ?>;document.getElementById('F1').submit();">
                                                                            Подарить за <?= $v['money'] ?> кр.
                                                                        </button>
                                                                    </td>
                                                                    <td style="vertical-align: top; border-right: 1px solid #a5a5a5; padding: 5px;">
                                                                        <a href="/item/0"><?= $v['linkname'] ?></a><br><small>Это именной подарок, его можете подарить только вы.</small>
                                                                    </td>
                                                                </tr>
                                                            </table>
                                                        </td>
                                                    </tr>
                                                <?php endforeach; ?>
                                                <tr>
                                                    <td style="text-align: center; background-color: lightgrey;"><h3>Стандартные подарки</h3></td>
                                                </tr>
                                            <?php endif; ?>
                                            <?= $itmAllSee ?>
                                        <?php elseif ($actionSale): ?>
                                            <?= $itmAllSee ?>
                                        <?php else: ?>
                                            <div class="wares">
                                                <?php $shop->printWares(); ?>
                                            </div>
                                        <?php endif; ?>
                                    </table>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
        <td style="width: 280px; vertical-align: top;">
            <div style="display: flex; align-items: flex-end; font-size: smaller; flex-direction: column; gap: 2px;">
                <?= $goLis; ?>
                <?php if ($shopId === ShopId::MAIN): ?>
                    <button onclick="location.href='main.php?loc=1.180.0.9&rnd=<?= $code; ?>'">Центральная Площадь</button>
                    <button onclick="location.href='main.php?loc=1.180.0.368&rnd=<?= $code; ?>'">Подпольная лавка</button>
                    <button onclick="location.href='main.php?loc=1.180.0.13&rnd=<?= $code; ?>'">Магазин «Берёзка»</button>
                <?php else: ?>
                    <button onclick="location.href='main.php?loc=1.180.0.10&rnd=<?= $code; ?>'">Государственный магазин</button>
                <?php endif; ?>
            </div>
            <div>
                <div style="display: grid; grid-template-columns: max-content max-content; font-size: smaller; justify-content: end; margin: 10px 0;">
                    <div style="text-align: right; margin-right: 5px;">Масса:</div>
                    <div style="font-weight: bold;"><?= $u->aves['now'] ?>/<?= $u->aves['max'] ?></div>
                    <div style="text-align: right; margin-right: 5px;">У вас в наличии:</div>
                    <div style="font-weight: bold; color: green"><?= $shop->getUserWallet() ?></div>
                </div>
                <div style="text-align: center;">
                    <?php if (!$actionSale): ?>
                        <INPUT class="btn" TYPE="button" value="Продать вещи" onclick="location='?otdel=<?= $otdel ?>&sale=1'">
                    <?php else: ?>
                        <INPUT class="btn" TYPE="button" value="Купить вещи" onclick="location='?otdel=<?= $otdel ?>'">
                    <?php endif; ?>
                    &nbsp;
                    <INPUT class="btn" TYPE="button" value="Обновить" onclick="location = '<?= str_replace('item', '', str_replace('buy', '', $_SERVER['REQUEST_URI'])); ?>';">
                </div>
                <BR>
            </div>
            <div style="background-color:#A5A5A5; padding:1px; text-align: center; font-weight: bold;">Отделы магазина</div>
            <div style="line-height:17px;">
                <?php
                /*названия разделов (справа)*/
                //$otdels = $shop->getUsedOtdels();
                $otdels[37] = "<span style='color: red'>$otdels[37]</span>";
                $otdels[100] = 'Сделать подарки';

                //$i = 1;
                foreach ($otdels as $k => $v) {
                    $color = $otdel === $k ? '#C7C7C7' : '#e2e0e0';
                    if (in_array($k, array_keys($shop->shopOtdel->getGroups()))) {
                        if ($i !== 1) {
                            echo '<br>';
                        }
                        echo sprintf('<div style="background-color: #d5d5d5;"><img src="/i/shop_ico/%s.png" alt="%s"> <strong>%s</strong></div>',
                            $i, $shop->shopOtdel->getGroups()[$k], $shop->shopOtdel->getGroups()[$k]);
                        $i++;
                    }
                    if ($k === 100) {
                        echo '<br><div style="background-color: #d5d5d5;"><b>Возможности:</b></div>';
                        $k = '32&gifts=1';
                    }
                    echo '<a href="?otdel=' . $k . '"><div style="background-color: ' . $color . '">&nbsp;&nbsp;' . $v . '</a></div>';
                }
                ?>
            </div>
        </td>
</table>
<br>
<div id="textgo" style="visibility:hidden;"></div>

